/* $Id: ftp.h,v 1.1.1.1 2000/02/28 19:59:51 leonard Exp $ */
/* Copyright David Leonard, 2000. All rights reserved. */

struct ftp_ctx {
	FILE *	f;			/* NULL if not connected */
	int	passive;
	char	username[256];
	char	hostname[256];
	char	password[256];
};

#define ftp_isconnected(ctx)	((ctx)->f != NULL)

struct ftp_response {
	int	code;
	char	msg[1024];
};

struct ftp_ctx * ftp_new_ctx(const char *, const char *, const char *, int);
int	ftp_connect(struct ftp_ctx *);
int	ftp_sendcmd(struct ftp_ctx *, struct ftp_response *, 
		const char *, ...);
int	ftp_vsendcmd(struct ftp_ctx *, struct ftp_response *, 
		const char *, va_list);
int	ftp_getresp(struct ftp_ctx *, struct ftp_response *);
int	ftp_voidresp(struct ftp_ctx *, struct ftp_response *); 
int	ftp_ntransfercmd(struct ftp_ctx *, struct ftp_response *, 
		const char *, ...);
int	ftp_abort(struct ftp_ctx *);				/* ABOR */
off_t	ftp_parse150(struct ftp_response *);			/* RETR */
int	ftp_parse227(struct ftp_response *, struct sockaddr *);	/* PASV */
char *	ftp_parse257(struct ftp_response *);			/* PWD */
int	ftp_quit(struct ftp_ctx *);				/* QUIT */
void	ftp_free_ctx(struct ftp_ctx *);

