/* $Id: main.c,v 1.4 2000/03/18 00:11:05 leonard Exp $ */
/* Copyright David Leonard, 2000. All rights reserved. */
#include <stdio.h>
#include <unistd.h>
#include <xfs/xfs_message.h>
#include <sys/stat.h>
#include "xfs.h"
#include "debug.h"
#include "node.h"
#include "null.h"
#include "nodeops.h"
#include "ftproot.h"
#include "user.h"

int
main(argc, argv)
	int argc;
	char *argv[];
{
	struct stat st;
	struct xfs_ctx *ctx;
	struct node *null;

	/* Get a new context with XFS */
	ctx = xfs_new(&nodeops);

	/* Craft a null node to act as parent to the root */
	null = null_new(ctx);

	st.st_mode = 0777;
	st.st_uid = 0;
	st.st_gid = 0;
#if 1
	root_node = user_new(null, "sushi.it.uq.edu.au", 0);
#else
	root_node = ftproot_new(null, 
	/*	"sushi.it.uq.edu.au", "ftp@mirror.aarnet.edu.au", */
		"localhost", "test",
		&st, 0);
#endif
	
	xfs_mainloop(ctx);

	exit(0);
}

