/* $Id: node_template.c,v 1.2 2000/02/29 04:15:50 leonard Exp $ */
/* Copyright David Leonard, 2000. All rights reserved. */
#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <sys/dirent.h>
#include <xfs/xfs_message.h>
#include "xfs.h"
#include "node.h"

/*
 * Template file: s/Template/something/g
 *		  s/Tn/sn/g;
 * extern struct node_class Template_class;
 */

/* Move these two lines into their own header file: */
extern struct node_class Template_class;
struct node * Template_new(void);

struct Template_node {
	struct node		node;
	/* private data follows */
};

static int
Template_getattr(Tn)
	struct Template_node *Tn;
{
	return 0;
}

static int
Template_putattr(Tn, st)
	struct Template_node *Tn;
	struct stat *st;
{
	return 0;
}

static int
Template_getdata(Tn)
	struct Template_node *Tn;
{
	return 0;
}

static int
Template_putdata(Tn)
	struct Template_node *Tn;
{
	return 0;
}

static int
Template_create(Tn, name, st)
	struct Template_node *Tn;
	const char *name;
	struct stat *st;
{
	return 0;
}

static int
Template_destroy(Tn, name)
	struct Template_node *Tn;
	const char *name;
{
	return 0;
}

static struct node *
Template_lookup(Tn, name, cred)
	struct Template_node *Tn;
	const char *name;
	struct ncred *cred;
{
	return NULL;
}

static int
Template_rename(Tn_from, name_from, n_to, name_to)
	struct Template_node *Tn_from;
	const char *name_from;
	struct node *n_to;
	const char *name_to;
{
	return 0;
}

static void
Template_dealloc(Tn)
	struct Template_node *Tn;
{
	node_deinit(&Tn->node);
	free(Tn);
}

static void
Template_repr(Tn, f)
	struct Template_node *Tn;
	FILE *f;
{
	fprintf(stderr, "<Template %p>", Tn);
}

struct node_class Template_class = {
	Template_getattr,	/* getattr */
	Template_putattr,	/* putattr */
	Template_getdata,	/* getdata */
	Template_putdata,	/* putdata */
	Template_create,	/* create  */
	Template_destroy,	/* destroy */
	Template_lookup,	/* lookup  */
	Template_rename,	/* rename  */
	Template_dealloc,	/* dealloc */
	Template_repr		/* repr    */
};


struct node *
Template_new()
{
	struct Template_node *Tn;

	Tn = (struct Template_node *)malloc(sizeof (struct Template_node));
	if (Tn == NULL)
		return NULL;
	node_init(&Tn->node, &Template_class, ctx);
	return (struct node *)Tn;
}
