/* $Id: null.c,v 1.1 2000/02/29 01:37:25 leonard Exp $ */
/* Copyright David Leonard, 2000. All rights reserved. */
#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <sys/dirent.h>
#include <xfs/xfs_message.h>
#include "xfs.h"
#include "node.h"
#include "null.h"

/*
 * null node
 */

struct null_node {
	struct node		node;
};

static void
null_dealloc(nn)
	struct null_node *nn;
{
	node_deinit(&nn->node);
	free(nn);
}

static void
null_repr(nn, f)
	struct null_node *nn;
	FILE *f;
{
	fprintf(stderr, "<null>");
}

struct node_class null_class = {
	(getattr_t)enodev,	/* getattr */
	(putattr_t)enodev,	/* putattr */
	(getdata_t)enodev,	/* getdata */
	(putdata_t)enodev,	/* putdata */
	(create_t)enodev,	/* create  */
	(destroy_t)enodev,	/* destroy */
	(lookup_t)enodev,	/* lookup  */
	(rename_t)enodev,	/* rename  */
	null_dealloc,		/* dealloc */
	null_repr		/* repr    */
};


struct node *
null_new(ctx)
	struct xfs_ctx *ctx;
{
	struct null_node *nn;

	nn = (struct null_node *)malloc(sizeof (struct null_node));
	if (nn == NULL)
		return NULL;
	node_init(&nn->node, &null_class, ctx);
	return (struct node *)nn;
}
